import type { Cheerio, CheerioAPI } from 'cheerio';
import type { Element } from 'domhandler';
import type { ImportKind } from 'esbuild';
import { type IDiagnostics } from './tools.js';
export type CheerElement = Cheerio<Element>;
export declare enum TagKind {
    script = 0,
    link = 1
}
export declare class Tag {
    readonly $elem: CheerElement;
    readonly field: string;
    readonly src: string;
    readonly kind: TagKind;
    constructor($elem: CheerElement);
    importKind(): ImportKind;
    isValid(): boolean | "";
    use(src: string): void;
    unuse(): void;
    toString(): string;
}
export declare class TagCollection {
    readonly $html: CheerioAPI;
    private readonly commonRoot;
    readonly htmlSource: string;
    private readonly tags;
    constructor($html: CheerioAPI, commonRoot: string, htmlSource: string);
    get size(): number;
    register(filepath: string, tag: Tag): void;
    apply(entryFile: string, cssBundle: string | undefined, _res: IDiagnostics): void;
    createDummyScript(): string;
}
//# sourceMappingURL=tag.d.ts.map